	PSR_IRQ_MODE            =   0x12
	PSR_SYS_MODE            =   0x1f
	WRAM_END                =   0x03008000
	INTR_VECTOR_BUF         =   (WRAM_END - 0x4)

	V_BLANK_INTR_FLAG       =   0x0001
	REG_BASE                =   0x04000000
	OFFSET_REG_IE           =   0x200

    .TEXT

    .GLOBAL     _start
_start:
    .INCLUDE    "rom_header.s"

    .EXTERN     AgbMain
    .GLOBAL     start_vector
    .CODE 32
start_vector:
        mov     r0, #PSR_IRQ_MODE
        msr     cpsr, r0
        ldr     sp, sp_irq
        mov     r0, #PSR_SYS_MODE
        msr     cpsr, r0
        ldr     sp, sp_usr
        ldr     r1, =INTR_VECTOR_BUF
        adr     r0, intr_main
        str     r0, [r1]
        ldr     r1, =AgbMain
        mov     lr, pc
        bx      r1
        b       start_vector

    .ALIGN
sp_usr: .word   WRAM_END - 0x100
sp_irq: .word   WRAM_END - 0x60


    .EXTERN     IntrTable
    .GLOBAL     intr_main
    .ALIGN
    .CODE 32

intr_main:
        mov     r3, #REG_BASE
        add     r3, r3, #OFFSET_REG_IE
        ldr     r2, [r3]
        and     r1, r2, r2, lsr #16
        mov     r2, #0
        ands    r0, r1, #V_BLANK_INTR_FLAG
        bne     jump_intr
        add     r2, r2, #4
jump_intr:
        strh    r0, [r3, #2]
        ldr     r1, =IntrTable
        add     r1, r1, r2
        ldr     r0, [r1]
        bx      r0

    .END

