#include	"gba.h"

#define	NUMBER_OF_RANDOM	0x10000

u8	s_nRandomIndex;
u16	s_nRandomTable[55];

static void	_sRandomize(void)
{
	s32	nData;
	u16	nLp1;

	for(nLp1 =0;nLp1 < 24;nLp1 ++) {
		nData = s_nRandomTable[nLp1] - s_nRandomTable[nLp1 + 31];
		if(nData >= 0)
				s_nRandomTable[nLp1] = nData;
		else	s_nRandomTable[nLp1] = nData + NUMBER_OF_RANDOM;
	}
	for(nLp1 = 24;nLp1 < 55;nLp1 ++) {
		nData = s_nRandomTable[nLp1] - s_nRandomTable[nLp1 - 24];
		if(nData >= 0)
				s_nRandomTable[nLp1] = nData;
		else	s_nRandomTable[nLp1] = nData + NUMBER_OF_RANDOM;
	}
}

void init_rand(u16 nSeed){
	u16	nIndex;
	s32	nData;
	u16	nLp1;
	

	for(nData=0;nData<55;nData++){
		s_nRandomTable[nData]=0;
	}
	nSeed %= NUMBER_OF_RANDOM;
	s_nRandomTable[54] = nSeed;
	nData = 1;
	for(nLp1 = 1;nLp1 < 56;nLp1 ++) {
		nIndex = 21 * nLp1 % 55;
		s_nRandomTable[nIndex] = nData;
		nData = nSeed - nData;
		if(nData < 0 )
			nData = nData + NUMBER_OF_RANDOM;
		nSeed = s_nRandomTable[nIndex];
	}
	s_nRandomIndex = 54;
}

u16	rand(void){
	u16			nResult;

	s_nRandomIndex ++;
	if(s_nRandomIndex > 54) {
		_sRandomize();
		s_nRandomIndex = 0;
	}
	nResult = s_nRandomTable[s_nRandomIndex];
	return nResult;
}

u16 nrand(u16 max){
	u16	nResult;
	nResult = max * rand() / NUMBER_OF_RANDOM;
	return nResult;
}
